// PWM (Puls Weiten Modulation) alle 20 ms einen Puls senden
#include <avr/io.h>
int sensorPin = A0; // PWM einlesen pin
int sensorValue = 0; // Sensor Messwert
int nullwert = 1540;
int ausgabewert = 1540;
int zwischenwert;
int x = 4; // speed wert default langsam
int i;
boolean taster;
unsigned long len;
void setup()
{
  pinMode (9, OUTPUT);
  pinMode (13, OUTPUT);
  pinMode (12, INPUT);
  pinMode (2, INPUT);
  Serial.begin(9600);
}
void loop()
{
  //prüfen ob schalter gedrückt wurde
  taster = digitalRead(12);
  if (taster == HIGH)
  {
    x++; // Speedwert um 1 erhöhen
    switch (x) {
      case 1:
        for (i = 0; i < x; i++) // 1 mal blinken um Speedwert an zu zeigen
        {
          digitalWrite(13, HIGH); 
          delay (250);
          digitalWrite(13, LOW);
          delay (250);
        }

        break;
      case 2:

        for (i = 0; i < x; i++) // 2 mal blinken um Speedwert an zu zeigen
        {
          digitalWrite(13, HIGH);
          delay (250);
          digitalWrite(13, LOW);
          delay (250);
        }
        break;
      case 3:
        for (i = 0; i < x; i++) // 3 mal blinken um Speedwert an zu zeigen
        {
          digitalWrite(13, HIGH);
          delay (250);
          digitalWrite(13, LOW);
          delay (250);
        }
        break;
      case 4:
        for (i = 0; i < x; i++) // 4 mal blinken um Speedwert an zu zeigen
        {
          digitalWrite(13, HIGH);
          delay (250);
          digitalWrite(13, LOW);
          delay (250);
        }

        break;
      case 5:
        digitalWrite(13, HIGH);
        delay (250);
        digitalWrite(13, LOW);
        delay (250);


        break;
    }
    if (x > 4) {// Speedwert auf 1 setzen wenn 5 erreicht wurde
      x = 1;
    }
  }
  // Lese Messwert vom sender ( kein gas ca 1540, vollgas ca 2050 microsekunden)
  len = pulseIn(2, HIGH);
  // Gebe Wert als PWM aus
  zwischenwert = len - nullwert ;
  if (x > 1 && zwischenwert < -280 )
  {
    zwischenwert = -280; // Rückwärtsgang in Sufe 2-4 auf 280 begrenzen, Stufe 1 ist offen.
    ausgabewert = nullwert + zwischenwert;
  }
  else
  {
    ausgabewert = nullwert + (zwischenwert) / x; // Ausgabewert mit Speedwert verrechnen
  }

  digitalWrite(9, HIGH); // pin9 high setzen
  delayMicroseconds(ausgabewert); // puls in microsekunden warten
  digitalWrite(9, LOW); //pin9 low setzen
  delay(20); // 20 ms warten
 // Serial.print (" eingelesen ");
 // Serial.print (len);
 // Serial.print (" errechnet ");
 // Serial.print (ausgabewert);
 // Serial.print (" zwischenwert ");
 // Serial.print (zwischenwert);
 // Serial.print (" teiler ");
 // Serial.println (x);
}
